#!/bin/sh

# Apparently we need to resort to this kind of kludges to work around
# AMT/MEI/QST/kernel/whatever bugs. A watchdog to keep meifand up and running.

# Kills the daemon, removes modules and restarts it
recover() {
	echo "*** Crashed detected. Trying to recover."

	killall meifand
	sleep 5
	killall -9 meifand
	sleep 30

	rmmod mei_me
	rmmod mei
	modprobe mei_me

	/usr/local/bin/meifand
}

/usr/local/bin/meifand

old=0

while true
do
	# Must be clearly longer than meifand update freq
	sleep 30

	# Check if heartbeat alive
	if [ -e /var/run/meifand ]
	then
		cur=`cat /var/run/meifand`

		# Crash...
		if [ $cur = $old ] ; then recover ; fi
		old=$cur
	else
		recover
	fi
done
