// Some global defines and types

#ifndef DEFINES_H
#define DEFINES_H

#define CONFIG_FILE "/etc/meifand.conf"
#define HEARTBEAT_FILE "/var/run/meifand"

#define MAXSENSORS 10
#define MAXFANS 10

#define CONSTANT 0
#define DYNAMIC 1
#define UNUSED 2

typedef struct fan_struct
{
	int type;
	float mintemp,maxtemp,
		  minduty,maxduty,
		  duty,oldduty;
} fan_t;

#endif
